package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10072MHQResultBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10072MHQSendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10072MHQCheckID extends ProtBase {




	private final short iTaskCode10072 = 10072;
	private Gson gson;
	private Prot10072MHQResultBean resMsgBean;
	
	public Prot10072MHQCheckID() {
		gson = new Gson();

	}
	public Prot10072MHQResultBean getResMsgBean() {
		return resMsgBean;
	}

	public void setResMsgBean(Prot10072MHQResultBean resMsgBean) {
		this.resMsgBean = resMsgBean;
	}








	public void dealCheckIDMHQ(SocketCreate create,
                               Prot10072MHQSendBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10072MHQSendBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10072, "开始请求协议");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10072MHQSendBean labelBean)
			throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10072, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10072, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10072, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resMsgBean = gson.fromJson(jsonData, Prot10072MHQResultBean.class);
		}
		recCheckCode(dis);
	}


}
